
#include "vlProperty.h"
#include "deftbl.h"

///out-file: vlProperty.h


///public:
VLValue vlGetProp(VLObjectPointer key, VLString attr, VLValue defaultValue)
{
  VLList l;
  l.append("::vlProperty::get");
  l.append(key);
  l.append(attr);
  l.append(defaultValue);
  return VLValue(l.eval());
}


///public:
VLValue vlSetProp(VLObjectPointer key, VLString attr, VLValue value)
{
  VLList l;
  l.append("::vlProperty::set");
  l.append(key);
  l.append(attr);
  l.append(value);
  return VLValue(l.eval());
}


///public:
DefTableKey vlKey(VLObjectPointer obj)
{
  DefTableKey key = (DefTableKey) VLVoidPointer(vlGetProp(obj, "KEY", VLVoidPointer(NoKey))).getPtr();
  if (key==NoKey) {
    key = NewKey();
    vlSetProp(obj, "KEY", VLVoidPointer(key));
  }
  return key;
}
