switch (CaseTbl[c = *p++]) {
case 0:	/* sentinel - probably EOB */
  if (c == '\0') {
    p = TokenStart = TokenEnd = auxNUL(TokenStart, 0);
    if (*p) extcode = NORETURN;
    else {
      p = TokenStart = TokenEnd = auxEOF(TokenStart, 0);
      if (*p) extcode = NORETURN;
      else { extcode = EOFTOKEN; EndOfText(p, 0, &extcode, v); }
    }
    goto done;
  } else {
    obstack_strgrow(Csm_obstk, "char '");
    obstack_cchgrow(Csm_obstk, c);
    message(
      ERROR,
      (char *)obstack_strcpy(Csm_obstk, "' is not a token"),
      0,
      &curpos);
    TokenEnd = p;
    continue;
  }
  
case 1:	/* space */
  while (scanTbl[c = *p++] & 1<<0) ;
  TokenEnd = p - 1;
  continue;
case 2:	/* tab */
  do { StartLine -= TABSIZE(p - StartLine); }
  while (scanTbl[c = *p++] & 1<<1);
  TokenEnd = p - 1;
  continue;
case 3:	/* newline */
  do { LineNum++; } while (scanTbl[c = *p++] & 1<<2);
  StartLine = (TokenEnd = p - 1) - 1;
  continue;

case 4:	/* Entered on:  A-H J-S U-Z a-z */
	St_9:
		/*  A-Z a-z*/
		while(scanTbl[(c= *p++)+0] & 1<< 3);--p;
			TokenEnd= p; /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;

case 5:	/* Entered on: [ */
	St_12:
		if( scanTbl[(c= *p++)+0] & 1<< 3){ /*  A-Z a-z */

		TokenEnd = TokenStart; /* prepare for error fallback */
			goto St_16;}
		else {TokenEnd=TokenStart;--p; goto fallback; }

case 6:	/* Entered on: T */
	St_11:
		if( scanTbl[(c= *p++)+0] & 1<< 4){ /*  A-G I-Z a-z */
			goto St_9;}
		else if(c =='H') {			goto St_15;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}

case 7:	/* Entered on: I */
	St_10:
		if( scanTbl[(c= *p++)+0] & 1<< 5){ /*  A-M O-Z a-z */
			goto St_9;}
		else if(c =='N') {			goto St_14;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}


default: TokenEnd=p; extcode=ExtCodeTbl[c]; goto done; /*  (-+ . | */
}
	St_14:
		if( scanTbl[(c= *p++)+0] & 1<< 6){ /*  A-B D-Z a-z */
			goto St_9;}
		else if(c =='C') {			goto St_17;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_17:
		if( scanTbl[(c= *p++)+0] & 1<< 7){ /*  A-K M-Z a-z */
			goto St_9;}
		else if(c =='L') {			goto St_22;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_22:
		if( scanTbl[(c= *p++)+128] & 1<< 0){ /*  A-T V-Z a-z */
			goto St_9;}
		else if(c =='U') {			goto St_26;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_26:
		if( scanTbl[(c= *p++)+128] & 1<< 1){ /*  A-C E-Z a-z */
			goto St_9;}
		else if(c =='D') {			goto St_28;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_28:
		if( scanTbl[(c= *p++)+128] & 1<< 2){ /*  A-H J-Z a-z */
			goto St_9;}
		else if(c =='I') {			goto St_29;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_29:
		if( scanTbl[(c= *p++)+0] & 1<< 5){ /*  A-M O-Z a-z */
			goto St_9;}
		else if(c =='N') {			goto St_30;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_30:
		if( scanTbl[(c= *p++)+128] & 1<< 3){ /*  A-F H-Z a-z */
			goto St_9;}
		else if(c =='G') {			goto St_31;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_31:
		if( scanTbl[(c= *p++)+0] & 1<< 3){ /*  A-Z a-z */
			goto St_9;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 11;
			goto done;
			}
	St_15:
		if( scanTbl[(c= *p++)+128] & 1<< 2){ /*  A-H J-Z a-z */
			goto St_9;}
		else if(c =='I') {			goto St_18;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_18:
		if( scanTbl[(c= *p++)+128] & 1<< 4){ /*  A-R T-Z a-z */
			goto St_9;}
		else if(c =='S') {			goto St_23;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 10;
			mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_23:
		if( scanTbl[(c= *p++)+0] & 1<< 3){ /*  A-Z a-z */
			goto St_9;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 2;
			goto done;
			}
	St_16:
		if( scanTbl[(c= *p++)+128] & 1<< 5){ /*   1.- 9. 11.-@ [-\ ^-` {-127. */
			goto St_19;}
		else if( scanTbl[c+0] & 1<< 3){ /*  A-Z a-z */
			goto St_20;}
		else if(c ==']') {			goto St_21;}
		else {--p; goto fallback; }
	St_21:
		if( scanTbl[(c= *p++)+0] & 1<< 3){ /*  A-Z a-z */
		extcode = 7;/* remember fallback*/
		TokenEnd = p-1;

		scan = NULL;
		proc = c_mkstr;
			goto St_24;}
		else {
			TokenEnd= (--p); /* FINAL, no auxscan, must set */
			extcode = 7;
			c_mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
			}
	St_24:
		/*  A-Z a-z*/
		while(scanTbl[(c= *p++)+0] & 1<< 3);--p;
		if((c= *p++) ==']') {			goto St_27;}
		else {--p; goto fallback; }
	St_27:
			TokenEnd= p; /* FINAL, no auxscan, must set */
			extcode = 7;
			c_mkstr(TokenStart, TokenEnd-TokenStart,&extcode,v);
			goto done;
	St_20:
		if( scanTbl[(c= *p++)+128] & 1<< 5){ /*   1.- 9. 11.-@ [-\ ^-` {-127. */
			goto St_19;}
		else if( scanTbl[c+0] & 1<< 3){ /*  A-Z a-z */
			goto St_25;}
		else if(c ==']') {			goto St_21;}
		else {--p; goto fallback; }
	St_25:
		/*  A-Z a-z*/
		while(scanTbl[(c= *p++)+0] & 1<< 3);--p;
		if( scanTbl[(c= *p++)+128] & 1<< 5){ /*   1.- 9. 11.-@ [-\ ^-` {-127. */
			goto St_19;}
		else if(c ==']') {			goto St_21;}
		else {--p; goto fallback; }
	St_19:
		if( scanTbl[(c= *p++)+0] & 1<< 3){ /*  A-Z a-z */
			goto St_24;}
		else {--p; goto fallback; }
