
namespace eval ::vlMessage {}

proc vlMessage::reset {} {
    variable data
    set data(messageList) ""
    set data(errorLevel) -1
}

proc vlMessage::getList {} {
    variable data
    return $data(messageList)
}

proc vlMessage::getErrorLevel {} {
    variable data
    return $data(errorLevel)
}

proc vlMessage::add {context type message} {
    variable data
    set tnames "NOTE WARNING ERROR"
    set colors "green yellow orange"
    lappend data(messageList) [list $context [lindex $colors $type] "[lindex $tnames $type]: $message"]
    set data(errorLevel) [max $data(errorLevel) $type]
}

