

#ifndef DrawingSpec_H
#define DrawingSpec_H

#include "VisAutoPatternCode.h"

extern char *WhiteColor;
extern char *BlackColor;
extern char *RedColor;
extern char *DarkBlueColor;
extern char *LightBlueColor;
extern char *GrayColor;
extern char *ComponentColor;
extern char *WebPageColor;
extern char *WebActionColor;
extern char *DataSourceColor;
extern char *DataSourceModifyColor;
extern char *___rootViewColor;
extern char *___NavitationBarViewColor;
extern char *___DataBaseViewColor;
extern char *__WebPageViewColor;
extern char *__WebActionViewColor;
extern char *__StyleSheetViewColor;
extern char *__GlobalFrameViewColor;
extern char *__StuffColor;

DECL_VECTORDRAWING(WebApplicationrootViewDrawing)

DECL_VECTORDRAWING(FormalParameterrootViewDrawing)

DECL_VECTORDRAWING(WebZonerootViewDrawing)

DECL_VECTORDRAWING(SubZonerootViewDrawing)

DECL_VECTORDRAWING(GlobalFramerootViewDrawing)

DECL_VECTORDRAWING(WebRolerootViewDrawing)

DECL_VECTORDRAWING(GlobalParameterrootViewDrawing)

DECL_VECTORDRAWING(WebPagerootViewDrawing)

DECL_VECTORDRAWING(WebPageInNavirootViewDrawing)

DECL_VECTORDRAWING(WebActionrootViewDrawing)

DECL_VECTORDRAWING(WebActionInNavirootViewDrawing)

DECL_VECTORDRAWING(LinkExternrootViewDrawing)

DECL_VECTORDRAWING(MetaInfoDrawing)

DECL_VECTORDRAWING(DatabaseIconDrawing)

DECL_VECTORDRAWING(StyleSheetIconDrawing)

DECL_VECTORDRAWING(NavigationBarIconDrawing)

DECL_VECTORDRAWING(NavigationBarTopDrawing)

DECL_VECTORDRAWING(NavigationBarBottomDrawing)

DECL_VECTORDRAWING(NavigationBarLeftDrawing)

DECL_VECTORDRAWING(NavigationBarRightDrawing)

DECL_VECTORDRAWING(DataBaseDrawing)

DECL_VECTORDRAWING(TableDataSourceDrawing)

DECL_VECTORDRAWING(DataSourceJoinDrawing)

DECL_VECTORDRAWING(LimitDataSourceDrawing)

DECL_VECTORDRAWING(DataSourceProjectionFilterDrawing)

DECL_VECTORDRAWING(DataSourceInsertDrawing)

DECL_VECTORDRAWING(DataSourceUpdateDrawing)

DECL_VECTORDRAWING(DataSourceDeleteDrawing)

DECL_VECTORDRAWING(WebPageDrawing)

DECL_VECTORDRAWING(FrameDrawing)

DECL_VECTORDRAWING(FormularRDrawing)

DECL_VECTORDRAWING(FormularGDrawing)

DECL_VECTORDRAWING(ListOutputElementDrawing)

DECL_VECTORDRAWING(ParagraphDrawing)

DECL_VECTORDRAWING(TextFragmentDrawing)

DECL_VECTORDRAWING(HeadingDrawing)

DECL_VECTORDRAWING(OutputElementDrawing)

DECL_VECTORDRAWING(FormularRadioGroupElementDrawing)

DECL_VECTORDRAWING(FormularRadioElementDisabledDrawing)

DECL_VECTORDRAWING(FormularRadioElementEnabledDrawing)

DECL_VECTORDRAWING(FormularCheckboxElementDisabledDrawing)

DECL_VECTORDRAWING(FormularCheckboxElementEnabledDrawing)

DECL_VECTORDRAWING(FormularSingleSelectElementDrawing)

DECL_VECTORDRAWING(FormularMultipleSelectElementDrawing)

DECL_VECTORDRAWING(WebActionDrawing)

DECL_VECTORDRAWING(WebActionDBOperationDrawing)

DECL_VECTORDRAWING(PHPOperationDrawing)

DECL_VECTORDRAWING(OperationDrawing)

DECL_VECTORDRAWING(ActionHandlerDrawing)

DECL_VECTORDRAWING(StyleSheetDrawing)

DECL_VECTORDRAWING(StyleSheetBlockDrawing)

DECL_VECTORDRAWING(StyleSheetPairValueDrawing)

DECL_VECTORDRAWING(GlobalFrameDrawing)

DECL_VECTORDRAWING(DataSourceActualParamDrawing)

DECL_VECTORDRAWING(WebPageActualParamDrawing)

DECL_VECTORDRAWING(ActualParamDrawing)

#endif
