
namespace eval ::codeoutput {
}

proc ::codeoutput::CodeSaveAsFile {out} {
  set filetypes [list \
     [list "All Files" *] \
    ]
  set filename [tk_getSaveFile -filetypes $filetypes -defaultextension ""]
  if {$filename == ""} {return 0}
  set openf $filename
  set f [open $openf w]
  puts $f [$out.text get 1.0 end]
  close $f
  #::CDlg::Information "Generated code saved to file '$filename' !!"
  return 1
}

proc ::codeoutput::opennew {title root} {
  #set client [::MDIFrame::New_Window $title "" -width 500]

  set id [abstractView::new $root -size "500 500"]
  oop::addClass $id "codeOutput"
  oop::data $id
  set data(viewType) $title

  set window $data(toplevel)

  #pack $window -expand true -fill both
  #set window [::MDIFrame::GetUserpath $client]

  frame $window.out
  text $window.out.text -relief sunken \
    -font "Courier -14" \
    -yscrollcommand [list $window.out.ys set] \
    -xscrollcommand [list $window.out.xs set] \
    -width 60 -height 3 -wrap none
  frame $window.menubar -relief raised -bd 2
  pack $window.menubar -fill x
  menubutton $window.menubar.file -text File -underline 0 -menu $window.menubar.file.menu
  pack $window.menubar.file -side left
  menu $window.menubar.file.menu
  $window.menubar.file.menu add command -label "Save As" -command "::codeoutput::CodeSaveAsFile $window.out"
  scrollbar $window.out.ys -orient vertical -command "$window.out.text yview"
  frame $window.out.bt
  scrollbar $window.out.xs -orient horizontal -command "$window.out.text xview"
  set pad [expr [$window.out.ys cget -width] + 2 * \
    ([$window.out.ys cget -bd] + [$window.out.ys cget -highlightthickness])]
  frame $window.out.pad -width $pad -height $pad
  pack $window.out.bt -side bottom -fill x
  pack $window.out.pad -in $window.out.bt -side right
  pack $window.out.xs -in $window.out.bt -side bottom -fill x
  pack $window.out.ys -side right -fill y
  pack $window.out.text -side right -fill both -expand true
  pack $window.out -side right -fill both -expand true
  #oop::setClass [::MDIFrame::GetClient $window] codeoutput
  return $window
}

proc ::codeoutput::addline {window text} {
  set line [$window.out.text index "end - 1 char"]
  $window.out.text insert $line "$text\n"
}

