
# Defines the representation of various codings for
# special character sequences.

namespace eval stringRep {}


proc stringRep::quoted {s} {
    if [empty $s] {
        return [i18n::text "(empty)"]
    }
    if { [string first "\n" $s] != -1 } {
        return [i18n::text "(multi-line string)"]
    }
    return "'$s'"
}

proc stringRep::nullValue {} {
    return "\#\#\#"
}

proc stringRep::nullValue2 {} {
    return [i18n::text "(not connected)"]
}

proc stringRep::unnamed {} {
    return "unnamed"
}

proc stringRep::getInitialName {class} {
    return "Unnamed$class"
}
